#ifndef CONSENSUS_H
#define CONSENSUS_H

#include <fstream>
#include <iostream>
#include <string>

class Tree;
class Model;

using namespace std;

class Consensus {
private:
    Tree* consensusTree;
    Model* consensusModel1;
    Model* consensusModel2;
    int expectedNumberSamples;

public:
    Consensus();

    int run( const string& mcmcControlFileName,
             const string& consensusTopologyFileName );
    
    int branchLengthsConsensus( ifstream& topologyFile,
                                ifstream& branchLengthsFile,
                                Tree* consensusTopology );
    int modelParametersConsensus( ifstream& modelParametersFile,
                                Model* consensusModel1, Model* consensusModel2,
                                  const string& plotBaseName );
};

#endif //CONSENSUS_H




