#ifndef MIXEDPERTURBATOR_H
#define MIXEDPERTURBATOR_H

#include <ostream>

#include <list>

#include "Util/randombox.h"

#include "PatternDesign/Singleton.h"

#include "Models/Perturbator.h"

#include "Models/Model.h"

class ParametersSet;

using namespace std;

class MixedPerturbator : public Perturbator {
protected:
    vector<Model*> models;
    vector<Model*> rndModels;
    
    vector<int> averageRateToModel;
    vector<double> averageRate;
    
    int lastModifiedModel;
    
public:
    MixedPerturbator( int numberModels );

    void registerModel( Model* model, int modelPrio,
            int averageRatePrio, double averageRateStep,
            double minAverageRatesAcceptanceRate, double maxAverageRatesAcceptanceTol);
            
    double perturb();

    bool validatePerturbation(bool validation);

    void printParameters( ostream & outputStream );

};

#endif //MIXEDPERTURBATOR_H




