#ifndef PERTURBATOR_H
#define PERTURBATOR_H

#include <vector>
#include <fstream>

#include "Util/randombox.h"
#include "PatternDesign/Singleton.h"
#include "Models/PerturbatorParameter.h"

using namespace std;

class ParametersSet;

class Perturbator {

protected:
    vector<PerturbatorParameter*> parameters;
    vector<PerturbatorParameter*> rndTable;
    Singleton < randombox > & rand;
    int lastModified;
    
public:
    Perturbator();

    void registerFrequencies( string name, vector<double> * frequencies, int freqPrio,
                    double freqStep,
            double minFreqAcceptanceRate = 0.0, double maxFreqAcceptanceRate = 1.0 );
    
    void registerGaussParameter( string name, double* element, int elementPrio,
                    double elementStep, double min, double max,
        double minElementAcceptanceRate = 0.0, double maxElementAcceptanceRate = 0.0 );

    double perturb();

    bool validatePerturbation(bool validation);
    
    void stopBurn();

    void printParameters( ostream & outputStream );
};

#endif //PERTURBATOR_H




