#ifndef PERTURBATORFREQUENCIESPARAMETER_H
#define PERTURBATORFREQUENCIESPARAMETER_H

#include "Util/randombox.h"
#include "PatternDesign/Singleton.h"
#include "Models/PerturbatorParameter.h"

class PerturbatorFrequenciesParameter : public PerturbatorParameter {
public:

    PerturbatorFrequenciesParameter(string name, vector<double> *pvalues, double step,
             double minAcceptance = 0.0, double maxAcceptance = 1.0);

    virtual double perturb();

    virtual bool validatePerturbation( bool validation );

    virtual void printParameter( ostream& outputStream );

private:    
    vector<double> * pvalues;
    vector<double> oldValues;
    double tuning;
    double tuningModifier;
    int lastModification;
    double minAcceptance;
    double maxAcceptance;
};

#endif //PERTURBATORFREQUENCIESPARAMETER_H
