#ifndef PERTURBATORGAUSSPARAMETER_H
#define PERTURBATORGAUSSPARAMETER_H

#include "Util/randombox.h"
#include "PatternDesign/Singleton.h"
#include "Models/PerturbatorParameter.h"

class PerturbatorGaussParameter : public PerturbatorParameter{

    
public:
    PerturbatorGaussParameter( string name, double* pvalue, double step,
                               double min, double max,
                 double minAcceptance = 0.0, double maxAcceptance = 1.0);

    virtual double perturb();

    virtual bool validatePerturbation( bool validation );
    
    virtual void printParameter( ostream& outputStream );
    
protected:
    double* pvalue;
    double oldValue;
    double step;
    double stepModifier;
    int lastModification;
    double min;
    double max;
    double minAcceptance;
    double maxAcceptance;
};

#endif //PERTURBATORGAUSSPARAMETER_H
