#ifndef SIMULATIONTREE_H
#define SIMULATIONTREE_H

#include "Tree/Tree.h"

#include "Models/Model.h"

#include "Util/randombox.h"
#include "PatternDesign/Singleton.h"

class SimulationTree : public Tree {
public:

    SimulationTree();

    SimulationTree( string stree );

    bool simulate( const vector<int> length );

    void printSequenceTable( ostream & out );

    void loadModel( Model * pmodel  );

private:
    vector< vector<int> > categories;
    vector< vector < vector<int> > > result;
};

#endif //SIMULATIONTREE_H




