#ifndef TREESSET_H
#define TREESSET_H

#include <iostream>

#include <string>
#include <vector>
using namespace std;

template <class T>
class Array;

class TreeModelValue;

class TreesSet : protected vector <TreeModelValue *> {
public :
    TreesSet( int maxNumberEntries ) ;
    ~TreesSet() ;

    bool insert( const string & stringTree,
                 const vector < double > & branchLengths,
                 const vector < double > & modelParameters,
                 double maxLikelihood );
    
    inline unsigned int size(){
        return vector <TreeModelValue *>::size();
    }
    
    TreeModelValue * get( int index );
    
protected:
    int maxNumberEntries;
};

#endif //TREESSET_H




