#ifndef PARAMETERSSET_H
#define PARAMETERSSET_H


using namespace std;

#include <vector>
#include <map>
#include <string>
#include <fstream>

class ParametersSet : public map < string, string > {
private:
    string name;
    bool autoRemoval;
    vector < ParametersSet > categories;

public:
    /** .*******************************************************************
     * ParametersSet
     * @input      The name of the set to be printed on the screen in case of
     *             error
     * @input      A boolean to indicate if a parameter must be removed from
     *             the set once retrieved
     * @semantics  Constructor of the set of parameter
     ************************************************************************ */
    ParametersSet( const string & setName, bool autoRemoval );

    bool boolParameter( const string & parameter );

    string stringParameter( const string & parameter );

    double doubleParameter( const string & parameter );

    ParametersSet & operator() ( const string & categoryName );

    void addCategory( string categoryName );

    bool findCategory( string categoryName );
    
    const string & getName() const;
    
    void setName( const string& newName );

    void saveToFile( ofstream & fileOutput, int indentation = 0 );

    int intParameter( const string & parameter );
};

#endif //PARAMETERSSET_H




