#include "Tree/ClustersSet.h"

ClustersSet::ClustersSet(ifstream& fileStream){

    char nextc;
    
    if ( fileStream == NULL ) {
        cerr << "Cluster file does not exist" << endl ;
        exit( 1 )  ;
    }

    // Read in clusters
    string clusterName;
    while ( !fileStream.eof() ) {
        nextc = ' ' ;
        clusterName.clear();
        while ( ( nextc != ';' ) && !fileStream.eof() ){
            fileStream.get( nextc ) ;
            if ( ( nextc != ';' ) && !isspace( nextc ) )
                clusterName += nextc ;
        }
        push_back( Cluster( clusterName, NULL ) );
        fileStream >> ws;
    }
    if ( nextc != ';' ) {
        cerr << "Error while reading cluster file" << endl ;
        exit( 1 )  ;
    }     
}

