#include "Util/ModelFactory.h"

#include "Models/Model.h"

#include <iostream>

Model * ModelFactory::create( string name, ParametersSet & parameters ) {
    map < string, const Model * >::iterator i = registry.find( name );
    if ( i == registry.end() ) {
        cerr << "Attempt to load an unregistered model" << endl;
        return NULL;
    }
    else {
        return ( ( * i ).second )->clone( parameters );
    }
}

void ModelFactory::subscribe( Model * prototype, string name  ) {
    map < string, const Model * >::iterator i = registry.find( name );
    assert ( i == registry.end() );
    registry[name] = prototype;
}


