#include "string_bag.h"

// Constructor
string_bag::string_bag() {
  unique_strings = 0 ;
  // Create space for 100 unique strings initially
  bag_size = 100 ;
  strings = new string[100] ;
  number_of_strings = new int[100] ;
}

// Destructor
string_bag::~string_bag() {
  if (strings != NULL) 
    delete[] strings ;
  if (number_of_strings != NULL)
    delete[] number_of_strings ;
}

// String_bag methods

void string_bag::expand() {
  string * newstrings = new string[2*bag_size] ;
  int    * new_number_of_strings = new int[2*bag_size] ;
  int i ;
  
  for (i=0 ; i<bag_size ; i++) {
    newstrings[i] = strings[i] ;
    new_number_of_strings[i] = number_of_strings[i] ;
  }
  delete[] strings ;
  delete[] number_of_strings ;
  strings = newstrings ;
  number_of_strings = new_number_of_strings ;
  bag_size *= 2 ;
  return ;
}

void string_bag::add(string &thestring) {
  int i=0 ;
  bool found = false ;
  while ((!found) && i<unique_strings)
    found = (thestring == strings[i++]);
  if (found)
    number_of_strings[i-1]++ ;
  else {    
    if ((unique_strings+1) > bag_size) {
      //cout << "expanding" << endl ;
      expand() ;
      //cout << "expanded" << endl ;
    }
    strings[unique_strings] = thestring ;
    number_of_strings[unique_strings] = 1 ;
    unique_strings++ ;
  }
  return ;
}

void string_bag::print(ostream &out) {
  int i ;
  sort() ;
  for (i=0 ; i<unique_strings ; i++)
    out << (i+1) << ". " << strings[i] << "\t" << number_of_strings[i] << endl ;
  return ;
}

void string_bag::sort() {
  int i =0 , j ;
  int swapn ;
  string swapstring ;
  // bubble sort
  while (i<unique_strings) {
    for (j=i+1 ; j<unique_strings ; j++) {
      if (number_of_strings[i] < number_of_strings[j]) {
	swapn = number_of_strings[i] ;
	swapstring = strings[i] ;
	number_of_strings[i] = number_of_strings[j] ;
	strings[i] = strings[j] ;
	number_of_strings[j] = swapn ;
	strings[j] = swapstring;
      }
    }
    i++ ;
  }
  return ;
}

int string_bag::find(string & search_string) {
  int i ;
  for (i=0 ; i<unique_strings ; i++) {
    if (strings[i] == search_string)
      return i ;
  }
  return -1 ;
} 

int string_bag::number_of_entries() {
  return unique_strings ;
}
